L2TP/IPSec一键安装脚本

技术 秋水逸冰 1103099 次围观 1077 次吐槽

Great Wall

本脚本适用环境:
系统支持:CentOS6+,Debian7+,Ubuntu12+
内存要求:≥128M
更新日期:2017 年 05 月 28 日

关于本脚本:
名词解释如下
L2TP(Layer 2 Tunneling Protocol)
IPSec(Internet Protocol Security)
IKEv2 (Internet Key Exchange v2)
能实现 IPsec 的目前总体上有 openswan,libreswan,strongswan 这3种。
libreswan 是基于 openswan 的 fork,所以现在各个发行版基本已经看不到 openswan 的身影了。
当然也有使用 strongswan 的。

之所以要更新 L2TP 一键安装脚本,是因为随着各个 Linux 发行版不断推陈出新,原有的脚本已经不适应现在的需求。
本脚本通过编译安装最新版 libreswan 来实现 IPSec(CentOS7 下则是全部 yum 安装),yum 或 apt-get 来安装 xl2tpd,再根据各个发行版的使用方法不同,部署防火墙规则。

写在前面:

基于 OpenVZ 虚拟化技术的 VPS 需要开启TUN/TAP才能正常使用,购买 VPS 时请先咨询服务商是否支持开启 TUN/TAP。

OpenVZ 虚拟的 VPS 需要系统内核支持 IPSec 才行。也就是说,母服务器的内核如果不支持的话那就没办法,只能换 VPS。
因此,一般不建议在 OpenVZ 的 VPS 上安装本脚本。脚本如果检测到该 VPS 为 OpenVZ 架构,会出现警告提醒。

如何检测是否支持TUN模块?
执行命令:
cat /dev/net/tun
如果返回信息为:cat: /dev/net/tun: File descriptor in bad state 说明正常

如何检测是否支持ppp模块?
执行命令:
cat /dev/ppp
如果返回信息为:cat: /dev/ppp: No such device or address 说明正常
当然,脚本在安装时也会执行检查,如果不适用于安装,脚本会予以提示。

使用方法:

root 用户登录后,运行以下命令:

wget --no-check-certificate https://raw.githubusercontent.com/teddysun/across/master/l2tp.sh
chmod +x l2tp.sh
./l2tp.sh

执行后,会有如下交互界面

L2TP

Please input IP-Range:
(Default Range: 192.168.18):
输入本地IP段范围(本地电脑连接到VPS后给分配的一个本地IP地址),直接回车意味着输入默认值192.168.18

Please input PSK:
(Default PSK: teddysun.com):
PSK意为预共享密钥,即指定一个密钥将来在连接时需要用到,直接回车意味着输入默认值teddysun.com

Please input Username:
(Default Username: teddysun):
Username意为用户名,即第一个默认用户。直接回车意味着输入默认值teddysun

Please input teddysun’s password:
(Default Password: Q4SKhu2EXQ):
输入用户的密码,默认会随机生成一个10位包含大小写字母和数字的密码,当然你也可以指定密码。

ServerIP:your_server_main_IP
显示你的 VPS 的主 IP(如果是多 IP 的 VPS 也只显示一个)

Server Local IP:192.168.18.1
显示你的 VPS 的本地 IP(默认即可)

Client Remote IP Range:192.168.18.2-192.168.18.254
显示 IP 段范围

PSK:teddysun.com
显示 PSK

Press any key to start…or Press Ctrl+c to cancel
按下任意按键继续,如果想取消安装,请按Ctrl+c键

安装完成后,脚本会执行 ipsec verify 命令并提示如下:

If there are no [FAILED] above, then you can connect to your
L2TP VPN Server with the default Username/Password is below:

ServerIP:your_server_IP
PSK:your PSK
Username:your usename
Password:your password

If you want to modify user settings, please use command(s):
l2tp -a (Add a user)
l2tp -d (Delete a user)
l2tp -l (List all users)
l2tp -m (Modify a user password)
Welcome to visit https://teddysun.com/448.html
Enjoy it!

如果你要想对用户进行操作,可以使用如下命令:
l2tp -a 新增用户
l2tp -d 删除用户
l2tp -m 修改现有的用户的密码
l2tp -l 列出所有用户名和密码
l2tp -h 列出帮助信息

其他事项:

1、脚本在安装完成后,已自动启动进程,并加入了开机自启动。
2、脚本会改写 iptables 或 firewalld 的规则。
3、脚本安装时,会即时将安装日志写到 /root/l2tp.log 文件里,如果你安装失败,可以通过此文件来寻找错误信息。

使用命令:

ipsec status (查看 IPSec 运行状态)
ipsec verify (查看 IPSec 检查结果)
/etc/init.d/ipsec start|stop|restart|status (CentOS6 下使用)
/etc/init.d/xl2tpd start|stop|restart (CentOS6 下使用)
systemctl start|stop|restart|status ipsec (CentOS7 下使用)
systemctl start|stop|restart xl2tpd (CentOS7 下使用)
service ipsec start|stop|restart|status (Debian/Ubuntu 下使用)
service xl2tpd start|stop|restart (Debian/Ubuntu 下使用)

更新日志

2017 年 05 月 28 日:
升级 libreswan 到版本 3.20。
修正 libreswan 的若干配置问题。
修正 xl2tpd 的端口监听配置问题。
修正在 CentOS 6 对 libevent2 的依赖问题,改为 yum 安装 libevent2-devel。
测试表明,在内网环境的 VPS 里(如AWS, IDCF,GCE,腾讯云,阿里云等)也可以正常使用了。

2017 年 02 月 25 日:
升级 libreswan 到版本 3.19。

2016 年 09 月 12 日:
修正了在 CentOS 6 下 libevent2 依赖的问题;
新增了一个 -m 选项,用以修改现有用户的密码。

2016 年 08 月 13 日:
修正 Debian 8 下的 sd-daemon.h: No such file or directory 问题,是由于缺少依赖包 libsystemd-daemon-dev 导致的。

2016 年 08 月 05 日:
升级 libreswan 到版本 3.18。

2016 年 06 月 10 日:
脚本在安装完成后,新增了几个命令,便于操作用户
l2tp -a 新增用户
l2tp -d 删除用户
l2tp -l 列出所有用户
l2tp -h 列出帮助信息

2016 年 04 月 25 日:
4、在 Vultr 的 Debian 7的系统模板下安装时,软件包 libcurl4-nss-dev 会出现依赖错误。如下所示:

The following packages have unmet dependencies:
libcurl4-nss-dev : Depends: libldap2-dev but it is not going to be installed
Depends: librtmp-dev but it is not going to be installed

而 libldap2-dev 和 librtmp-dev 又依赖了其他几种软件包。总之最后的依赖关系如下:

libldap2-dev : Depends: libldap-2.4-2 (= 2.4.31-2+deb7u1) but 2.4.31+really2.4.40+dfsg-1+deb8u1~bpo70+1 is to be installed
librtmp-dev : Depends: libgnutls-dev but it is not going to be installed
libgnutls-dev : Depends: libp11-kit-dev (>= 0.4) but it is not going to be installed
libp11-kit-dev : Depends: libp11-kit0 (= 0.12-3) but 0.20.7-1~bpo70+1 is to be installed

那么解决办法就是把最底层的依赖包 libp11-kit0 先卸载掉,然后再安装 libcurl4-nss-dev 即可。

apt-get -y remove libp11-kit0
apt-get -y --no-install-recommends install libcurl4-nss-dev wget

然后再运行脚本安装即可。

2016 年 04 月 22 日:
修复了在 Ubuntu 16.04 下因为默认缺少 python 命令而导致 ipsec verify 等命令不能用的问题。

2016 年 04 月 19 日:
修复了在 Debian 7 下因为 libnss3 和 libnspr4 的版本过低而导致编译 libreswan 失败的问题。

2016 年 04 月 18 日:
目前在 Debian 7 上测试的结果,因为 libnss3 和 libnspr4 的版本过低而导致编译 libreswan 失败。临时解决办法是 dpkg 安装 libnss3_3.17.2 和 libnspr4_4.10.7 的 deb 包后重试。

参考链接:
https://libreswan.org/wiki/3.14_on_Debian_Wheezy
https://github.com/libreswan/libreswan

转载请注明:秋水逸冰 » L2TP/IPSec一键安装脚本

发表我的评论
取消评论
表情

Hi,您需要填写昵称和邮箱!

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址

网友最新评论 (1077)

  1. 用在了一个香港VPS上,结果今天200G流量被跑完了,管理员说是脚本的问题,会偷跑流量,不知道该相信谁~~~~~
    斯文书生2年前 (2017-03-10)回复
  2. 我的vpn变为centos7 xl2tpd 启动失败.日志如下 systemctl -l status xl2tpd ● xl2tpd.service - Level 2 Tunnel Protocol Daemon (L2TP) Loaded: loaded (/usr/lib/systemd/system/xl2tpd.service; enabled; vendor preset: disabled) Active: failed (Result: start-limit) since Wed 2017-03-08 15:15:05 UTC; 1min 7s ago Process: 22100 ExecStartPre=/sbin/modprobe -q l2tp_ppp (code=exited, status=1/FAILURE) Mar 08 15:15:05 li1587-106 systemd[1]: xl2tpd.service: control process exited, code=exited status=1 Mar 08 15:15:05 li1587-106 systemd[1]: Failed to start Level 2 Tunnel Protocol Daemon (L2TP). Mar 08 15:15:05 li1587-106 systemd[1]: Unit xl2tpd.service entered failed state. Mar 08 15:15:05 li1587-106 systemd[1]: xl2tpd.service failed. Mar 08 15:15:05 li1587-106 systemd[1]: xl2tpd.service holdoff time over, scheduling restart. Mar 08 15:15:05 li1587-106 systemd[1]: start request repeated too quickly for xl2tpd.service
    Tanlet2年前 (2017-03-08)回复
  3. In file included from /home/soft/l2tp/l2tp/libreswan-3.19/include/lswlog.h:40:0, from /home/soft/l2tp/l2tp/libreswan-3.19/lib/libswan/alg_info.c:23: /home/soft/l2tp/l2tp/libreswan-3.19/include/constants.h:107:45: fatal error: prcpucfg.h: No such file or directory compilation terminated. ../../../mk/depend.mk:28: recipe for target 'alg_info.o' failed make[3]: *** [alg_info.o] Error 1 make[3]: Leaving directory '/home/soft/l2tp/l2tp/libreswan-3.19/OBJ.linux.x86_64/lib/libswan' Makefile:98: recipe for target 'local-base' failed make[2]: *** [local-base] Error 2 make[2]: Leaving directory '/home/soft/l2tp/l2tp/libreswan-3.19/lib/libswan' ../mk/targets.mk:82: recipe for target 'recursive-all' failed make[1]: *** [recursive-all] Error 2 make[1]: Leaving directory '/home/soft/l2tp/l2tp/libreswan-3.19/lib' mk/targets.mk:82: recipe for target 'recursive-all' failed make: *** [recursive-all] Error 2 libreswan-3.19 install failed. Ubuntu16.04安装失败
    Tanlet2年前 (2017-03-08)回复
  4. 博主您好:使用您的一键包后,ipsec verify提示 Checking for obsolete ipsec.conf options [OBSOLETE KEYWORD] Warning: ignored obsolete keyword 'nat_traversal' Warning: ignored obsolete keyword 'oe' 安装后无法连上,日志提示: The remote system is required to authenticate itself but I couldn't find any suitable secret (password) for it to use to do so. (None of the available passwords would let it use an IP address.) google查找都说是因为用户信息那里没有用*结尾,可是我是按照标准的user l2tpd pwd *这样的格式写的,实在是自己解决不了了 能不能帮忙看下?
    leo2年前 (2017-03-08)回复
  5. 你好,请问一下我用了脚本安装完成都没有问题,连接时却连接不上,登录不上然后提示800错误,请问一下作者这是什么问题?
    小羊快跑2年前 (2017-03-07)回复
  6. 老大,我用linode的服务器建好之后,可以正常使用,但是我叫linode给我换了ip之后,就连不上了,linode给我换好ip,我只是重新启动了下服务器,就换成了新IP,其他设置都没有动,就无法连上了,重新安装本一键包也连接不上,请问是不是换ip就不行了?如果是,能告诉我个解决方法吗??我现在是重装服务器系统,然后安装一键包,又可以上了,但是每次都要格式化vps太麻烦了,有简便点的方法吗??请指教,谢谢。
    jackyeow2年前 (2017-03-06)回复
  7. Ubuntu 下 libreswan-3.19 install failed.
    junjun2年前 (2017-03-04)回复
  8. teddy, 您文中提到同一个局域网内,多人连接出现问题,后面给出了一个链接,说按上面操作。能具体说一下吗?是根据里面修改/etc/ipsec.conf内容就可以了吗?还是每个配置文件都要修改内容?多谢!
    Jeff2年前 (2017-03-03)回复
  9. 小白前来反馈,从1月份开始用一键安装包. 用linode的vps安装. CentOS7稳定运行了1个月,期间各种运营商网络都试过(移动电信)设备包括Iphone7plus,iphone7,ipadmini2均能顺畅连上而且速度很快. 记得当时看到安装包最后更新是1月10几号的样子. 最近发现会被陌生人SSH尝试登陆,然而并没有登陆上,尝试登陆次数并不高,几天20000多次的样子.但是不知道为什么会导致网速降低,而且很难连上VPS,有时候能连上有时候不行.最后忍不住关闭SSH登陆换了RSA登陆方式.然而L2TP的连接问题一直存在,SSH被尝试登陆的问题解决. 现在这半个月一直在研究L2TP连接问题,最近又翻回此文章,然后再次用最新版本的一键安装包安装同样在CentOS7上,出现的问题是只有在安装过程中输入的账号能连接上L2TP之后添加的账号无论是以命令形式还是vim添加的都不能登录.提示无法连接L2TP-VPN........然后最初输入的账号也会很快不能用. 查看了很多评论,说换系统,所以昨天我换了Debian8安装. SSH尝试登陆问题解决,我也没换IP.还有L2TP问题也解决,能在iphone和win8上正常连接,但是ipad总是连接不上,换了其他ipad也不行. 以上是使用反馈. 现在的问题是用了debian8安装L2TP,ipad连接不了,提示L2TP-VPN无法连接........ 我该去哪个log里面查连接日志,求大神回复.
    skykes2年前 (2017-03-02)回复
  10. 请问支持ipv6吗?
    steven2年前 (2017-02-27)回复
  11. 刚刚提交的问题,通过命令 xl2tpd -D 来运行的话,就可以解决。就可以顺利连接,请问这个问题应该如何修复呢?
    Oran2年前 (2017-02-26)回复
  12. 在Linode KVM架构的VPS上,CENTOS7 系统测试失败,连接不了。CENTOS6系统下正常可用。奇怪的问题 错误日志: Feb 26 02:52:54 li1560-239 systemd[1]: xl2tpd.service: control process exited, code=exited status=1 Feb 26 02:52:54 li1560-239 systemd[1]: Failed to start Level 2 Tunnel Protocol Daemon (L2TP). Feb 26 02:52:54 li1560-239 systemd[1]: Unit xl2tpd.service entered failed state. Feb 26 02:52:54 li1560-239 systemd[1]: xl2tpd.service failed. Feb 26 02:52:54 li1560-239 systemd[1]: xl2tpd.service holdoff time over, scheduling restart. Feb 26 02:52:54 li1560-239 systemd[1]: start request repeated too quickly for xl2tpd.service Feb 26 02:52:54 li1560-239 systemd[1]: Failed to start Level 2 Tunnel Protocol Daemon (L2TP). Feb 26 02:52:54 li1560-239 systemd[1]: Unit xl2tpd.service entered failed state. Feb 26 02:52:54 li1560-239 systemd[1]: xl2tpd.service failed.
    Oran2年前 (2017-02-26)回复
  13. 在Linode KVM架构的VPS上,CENTOS7 系统测试失败,连接不了。CENTOS6系统下正常可用。奇怪的问题。
    Oran2年前 (2017-02-26)回复
  14. 大神你好,我不想当伸手党的,借鉴你的脚本研究了不少,可是有个问题老是解决不了。 你的脚本在一个KVM的VPS上运行成功了也能正常连接,centos系统的,好像是6.x 在我家自己装的CentOS7.3准系统上就不行了,systemctl status ipsec显示如下 Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT"[5] 10.27.0.222 #12: STATE_QUICK_R1: sent QR1, inbound IPsec SA installed, expecting QI2 transport mode {ESP=>0x08da28bc 0x08da28bc <0x0e5a2e3f xfrm=AES_256-HMAC_SHA1 NATOA=none NATD=none DPD=active} Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT"[5] 10.27.0.222 #11: received Delete SA(0x08da28bc) payload: deleting IPSEC State #12 Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT"[5] 10.27.0.222 #11: deleting state #12 (STATE_QUICK_R2) Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT"[5] 10.27.0.222 #11: ESP traffic information: in=268B out=204B Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT" #11: deleting state #11 (STATE_MAIN_R3) Feb 25 02:21:14 localhost.localdomain pluto[9070]: "L2TP-PSK-noNAT"[5] 10.27.0.222: deleting connection "L2TP-PSK-noNAT" instance with peer 10.27.0.222 {isakmp=#0/ipsec=#0} Feb 25 02:21:14 localhost.localdomain pluto[9070]: packet from 10.27.0.222:500: received and ignored empty informational notification payload sudo ipsec verify 的输出如下 Version check and ipsec on-path [OK] Libreswan 3.15 (netkey) on 4.9.9-1.el7.elrepo.x86_64 Checking for IPsec support in kernel [OK] NETKEY: Testing XFRM related proc values ICMP default/send_redirects [OK] ICMP default/accept_redirects [OK] XFRM larval drop [OK] Pluto ipsec.conf syntax [OK] Hardware random device [N/A] Two or more interfaces found, checking IP forwarding [OK] Checking rp_filter [OK] Checking that pluto is running [OK] Pluto listening for IKE on udp 500 [OK] Pluto listening for IKE/NAT-T on udp 4500 [OK] Pluto ipsec.secret syntax [OK] Checking 'ip' command [OK] Checking 'iptables' command [OK] Checking 'prelink' command does not interfere with FIPSChecking for obsolete ipsec.conf options [OK] Opportunistic Encryption [DISABLED] 谢谢大神
    a17uk2年前 (2017-02-25)回复
    • 在写这个脚本的时候,防火墙这块的逻辑,就是映射了公网 IP 端口。 如果是在本地没有公网的虚拟机里安装的话,建议找官方的 Wiki 看看。
      秋水逸冰2年前 (2017-02-25)回复
  15. Feb 20 18:06:26 nahqw8qu pppd[1977]: Cannot determine ethernet address for proxy ARP 求解答,麻烦了!这是什么问题,找了好长时间没解决呢
    未来星2年前 (2017-02-20)回复